---

stages:
  - build
  - test

# yamllint disable rule:line-length
# yamllint disable rule:indentation
.lint-script: &lint-script |
  # BEGSCRIPT
  echo "🕵️ checking if commitlint config file is present"
  if [ ! -f "${COMMITLINT_CONFIG_FILE}" ]
  then
    echo "🔧 using default configuration for commitlint"
    echo "module.exports = {  extends: ['@commitlint/config-conventional'], rules: {'body-max-line-length': [0, 'always', 150]} };" > "${COMMITLINT_CONFIG_FILE}"
  fi
  # ENDSCRIPT
# yamllint enable rule:indentation
# yamllint enable rule:line-length

lint:commit:
  stage: build
  image:
    name: commitlint/commitlint:latest
    entrypoint: [""]
  variables:
    COMMITLINT_CONFIG_FILE: commitlint.config.js
  before_script:
    - apk add --no-cache git
    - git config --global --add safe.directory "${CI_PROJECT_DIR}"
  script:
    - *lint-script
    - commitlint --color --verbose --from "${CI_MERGE_REQUEST_DIFF_BASE_SHA}"
      --to HEAD
  rules:
    - if: '$COMMIT_CHECK_DISABLED == "true" || $JOBS_DISABLED == "true"'
      when: never
    - if: '$CI_COMMIT_MESSAGE =~ /skip-commitlint/'
      when: never
    - if: $CI_MERGE_REQUEST_ID
